/**
 * content script
 * @author GavinGong
 * @package triptain-chrome-extension-spider-zh
 */


/**
 * --------------------------------------------------------------
 * 初始化Inject HTML
 * --------------------------------------------------------------
 */
$("body").append("<div class='btn btn-app bg-success' id='triptain_btn_download'>采集</div>");
$("body").append("<div id='rule_download'><div class='card card-default'><div class='card-header text-center'></div><div class='card-body'></div></div></div>");
update_form();

/**
 * --------------------------------------------------------------
 * 悬浮按钮点击事件
 * --------------------------------------------------------------
 */
$(document).on("click", '#triptain_btn_download', function () {
    $('#rule_download').toggle();
    $("#rule_download #lirun").val('');
});

/**
 * --------------------------------------------------------------
 * 细分市场选择事件
 * --------------------------------------------------------------
 */
$(document).on("change", '#rule_download #tag', function () {
    let tag_id = $(this).val();
    chrome.storage.local.set({current_tag_id: tag_id}, function () {
        console.log(tag_id);
    });
});

/**
 * --------------------------------------------------------------
 * 表单提交事件
 * --------------------------------------------------------------
 */
$(document).on("click", '#btn_download', function () {
    let lirun = $("#rule_download #lirun").val();
    let tag = $("#rule_download #tag").val();

    if (lirun.length === 0) {
        $("#rule_download #lirun").css({"border-color": "red"}).focus();
        return;
    } else {
        $("#rule_download #lirun").css({"border-color": "rgb(206, 212, 218)"});
    }

    if (tag.length === 0) {
        $("#rule_download #tag").css({"border-color": "red"}).focus();
        return;
    } else {
        $("#rule_download #tag").css({"border-color": "rgb(206, 212, 218)"});
    }

    //禁用提交表单
    $('#btn_download').attr("disabled", true).text("提交中，请稍后...");


    chrome.storage.local.get(['user_id', 'current_shop_id'], function (result) {
        let _user_id = result.user_id;
        let _shop_id = result.current_shop_id;
        let _url = window.location.href;
        let _title = $('#rule_download #title').val();
        let _supplier_item = $('#rule_download #supplier_item').val();
        let _lirun = $('#rule_download #lirun').val();
        let _tag = $('#rule_download #tag').val();
        let _body = $('body').html();

        $.post("https://erp.loophot.com/open/shop/download_plan", {
                user_id: _user_id,
                shop_id: _shop_id,
                url: _url,
                title: _title,
                supplier_item: _supplier_item,
                lirun: _lirun,
                tag: _tag,
                body: _body
            },
            function (data) {
                //取消button禁用状态
                if (data.code === '0') {
                    $('#btn_download').text('提交成功').attr('id', '').css({'color': '#fff', 'background-color': '#6c757d', 'border-color': '#6c757d'});
                } else {
                    $('#btn_download').attr("disabled", false).text('重新采集');
                }
            }, "json");
    });
});

/**
 * --------------------------------------------------------------
 * 监听popup消息并执行
 * --------------------------------------------------------------
 */
chrome.runtime.onMessage.addListener((request, sender, sendResponse) => {
    //request.name login|logout|select_shop
    update_form();
});

function update_form() {
    chrome.storage.local.get(['user_id', 'user_shops', 'current_shop_id', 'current_shop_tags', 'current_tag_id'], function (result) {
        const domain = document.domain;
        let location = domain.indexOf('jp') > 0 ? 'jp' : 'cn';
        if (domain.indexOf('ja.aliexpress.com') > 0) {
            location = 'jp';
        }

        //--------------------------------- 未登录
        if (typeof (result.user_id) === "undefined") {
            //修改表单header
            $('#rule_download .card-header').text('尚未登录');
            //修改表单body
            $('#rule_download .card-body').html('<div class="text-center">请先在popup中登录并选择选品店铺</div>');
            //删除表单footer
            $('#rule_download .card-footer').remove();
        } else {
            //--------------------------------- 已登录未选择店铺
            if (typeof (result.current_shop_id) === "undefined") {
                //修改表单header
                $('#rule_download .card-header').text('未选择店铺');
                //修改表单body
                $('#rule_download .card-body').html('<div class="text-center">请在popup中选择需要选品的店铺</div>');
                //删除表单footer
                $('#rule_download .card-footer').remove();
            } else {
                //----------------------------- 已登录并选择了店铺

                //-------- 修改表单header
                $('#rule_download .card-header').text(result.user_shops[result.current_shop_id]);

                //-------- 修改表单footer
                if ($('#rule_download .card-footer').length === 0) {
                    $('#rule_download .card').append("<div class='card-footer'><button class='btn btn-outline-primary btn-block' id='btn_download'>提交</button></div>");
                }

                //-------- 修改表单footer
                let card_body = $('#rule_download .card-body');
                card_body.html('');
                if (location === 'cn') {
                    card_body.append("<div class='form-group'><label for='title'>产品标题</label><input type='text' class='form-control' id='title' placeholder='产品日语标题，留空则使用当前产品标题'></div>");
                }
                if (location === 'jp') {
                    card_body.append("<div class='form-group'><label for='supplier_item'>供应商</label><input type='url' class='form-control' id='supplier_item' placeholder='当前产品的采购链接，可留空'></div>");
                }
                card_body.append("<div class='form-group'><label for='lirun'>" + (location === 'jp' ? "产品加价 *" : "产品利润 *") + "</label><input type='number' class='form-control' id='lirun' placeholder='" + (location === 'jp' ? "产品加价(单位日元)，必须是整数" : "产品利润(单位人民币)，必须是整数") + "' required></div>");
                //-------- 修改表单footer
                let tag_html = "<div class='form-group mb-0'><label for='tag'>细分市场 *</label>";
                tag_html += "<select class='form-control' id='tag'>";
                if (result.current_shop_tags.length === 0) {
                    tag_html += "<option value='0'>未知细分市场</option>";
                } else {
                    //---------- 不存在之前选择的tag
                    if (typeof (result.current_tag_id) === "undefined") {
                        tag_html += "<option value=''>请选择细分市场...</option>";
                        for (let key in result.current_shop_tags) {
                            tag_html += "<option value='" + key + "'>" + result.current_shop_tags[key] + "</option>";
                        }
                    } else {
                        tag_html += "<option value=''>请选择细分市场...</option>";
                        for (let key in result.current_shop_tags) {
                            tag_html += "<option value='" + key + "'";
                            if (result.current_tag_id === key) {
                                tag_html += " selected"
                            }
                            tag_html += ">" + result.current_shop_tags[key] + "</option>";
                        }
                    }
                }
                tag_html += "</select></div>";


                card_body.append(tag_html);
            }
        }
    });
}